" Vim syntax file
" Language:      Igor Pro
" Maintainer:    Thomas Braun <thomas.braun at byte-physics dot de>
" Last Modified: XXX
" Filetype:      *.ipf
" Remark:        Based on the original version by Peter Li <peterli@spam.eriifiic.salk.edu>

" TODO note operation vs note function

" The list of functions and operations has been generated by:
" ###########################################################
" Function gatherDataForVim()
"
" 	string opList   = SortList(OperationList("*",";",""))
" 	string funcList = SortList(FunctionList("*",";","KIND:5"))
"
" 	print "\" Operations {{{"
" 	OutputVimList("syn keyword igorOperation", opList)
" 	print "\" }}}"
" 	print "\r"
" 	print "\" Functions {{{"
" 	OutputVimList("syn keyword igorFunction", funcList)
" 	print "\" }}}"
" End
"
" Function OutputVimList(prefix,list)
" 	string list, prefix
"
" 	variable numItems = ItemsInList(list,";")
"
" 	string str = prefix
" 	string item
"
" 	variable i
" 	for(i=0; i < numItems; i+=1)
" 		item = StringFromList(i,list)
"
" 		if( strlen(item) <= 1) // skip single character items
" 			continue
" 		endif
"
" 		if( (strlen(str) + strlen(item) + 1) > 80)
" 			print str
" 			str = prefix
" 		endif
" 		str += " " + item
" 	endfor
"
" 	print str
" End
" ###########################################################

if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn case ignore

" Operations {{{
syn keyword igorOperation APMath Abort AddFIFOData AddFIFOVectData AddMovieAudio
syn keyword igorOperation AddMovieFrame AdoptFiles Append AppendImage
syn keyword igorOperation AppendLayoutObject AppendMatrixContour AppendText
syn keyword igorOperation AppendToGizmo AppendToGraph AppendToLayout
syn keyword igorOperation AppendToTable AppendXYZContour AutoPositionWindow
syn keyword igorOperation AxonTelegraphFindServers BackgroundInfo Beep
syn keyword igorOperation BoundingBall BoxSmooth BrowseURL BuildMenu Button CWT
syn keyword igorOperation Chart CheckBox CheckDisplayed ChooseColor Close
syn keyword igorOperation CloseHelp CloseMovie CloseProc ColorScale
syn keyword igorOperation ColorTab2Wave Concatenate ControlBar ControlInfo
syn keyword igorOperation ControlUpdate ConvertGlobalStringTextEncoding
syn keyword igorOperation ConvexHull Convolve CopyFile CopyFolder CopyScales
syn keyword igorOperation Correlate CreateAliasShortcut CreateBrowser Cross
syn keyword igorOperation CtrlBackground CtrlFIFO CtrlNamedBackground Cursor
syn keyword igorOperation CurveFit CustomControl DAQmx_AI_SetupReader
syn keyword igorOperation DAQmx_AO_SetOutputs DAQmx_CTR_CountEdges
syn keyword igorOperation DAQmx_CTR_OutputPulse DAQmx_CTR_Period
syn keyword igorOperation DAQmx_CTR_PulseWidth DAQmx_DIO_Config
syn keyword igorOperation DAQmx_DIO_WriteNewData DAQmx_Scan DAQmx_WaveformGen
syn keyword igorOperation DPSS DSPDetrend DSPPeriodogram DWT Debugger
syn keyword igorOperation DebuggerOptions DefaultFont DefaultGuiControls
syn keyword igorOperation DefaultGuiFont DefaultTextEncoding DefineGuide
syn keyword igorOperation DelayUpdate DeleteAnnotations DeleteFile DeleteFolder
syn keyword igorOperation DeletePoints Differentiate Display DisplayHelpTopic
syn keyword igorOperation DisplayProcedure DoAlert DoIgorMenu DoUpdate DoWindow
syn keyword igorOperation DoXOPIdle DrawAction DrawArc DrawBezier DrawLine
syn keyword igorOperation DrawOval DrawPICT DrawPoly DrawRRect DrawRect DrawText
syn keyword igorOperation DrawUserShape Duplicate DuplicateDataFolder EdgeStats
syn keyword igorOperation Edit ErrorBars EstimatePeakSizes Execute
syn keyword igorOperation ExecuteScriptText ExperimentModified ExportGizmo
syn keyword igorOperation Extract FBinRead FBinWrite FFT FIFO2Wave FIFOStatus
syn keyword igorOperation FPClustering FReadLine FSetPos FStatus
syn keyword igorOperation FTPCreateDirectory FTPDelete FTPDownload FTPUpload
syn keyword igorOperation FastGaussTransform FastOp FilterFIR FilterIIR
syn keyword igorOperation FindAPeak FindContour FindDuplicates FindLevel
syn keyword igorOperation FindLevels FindPeak FindPointsInPoly FindRoots
syn keyword igorOperation FindSequence FindValue FuncFit FuncFitMD GBLoadWave
syn keyword igorOperation GISCreateVectorLayer GISGetRasterInfo
syn keyword igorOperation GISGetRegisteredFileInfo GISGetVectorLayerInfo
syn keyword igorOperation GISLoadRasterData GISLoadVectorData
syn keyword igorOperation GISRasterizeVectorData GISRegisterFile
syn keyword igorOperation GISTransformCoords GISUnRegisterFile GISWriteFieldData
syn keyword igorOperation GISWriteGeometryData GISWriteRaster GPIB2 GPIBRead2
syn keyword igorOperation GPIBReadBinary2 GPIBReadBinaryWave2 GPIBReadWave2
syn keyword igorOperation GPIBWrite2 GPIBWriteBinary2 GPIBWriteBinaryWave2
syn keyword igorOperation GPIBWriteWave2 GetAxis GetCamera GetFileFolderInfo
syn keyword igorOperation GetGizmo GetLastUserMenuInfo GetMarquee GetMouse
syn keyword igorOperation GetSelection GetWindow GraphNormal GraphWaveDraw
syn keyword igorOperation GraphWaveEdit Grep GroupBox HDF5CloseFile
syn keyword igorOperation HDF5CloseGroup HDF5ConvertColors HDF5CreateFile
syn keyword igorOperation HDF5CreateGroup HDF5CreateLink HDF5Dump HDF5DumpErrors
syn keyword igorOperation HDF5DumpState HDF5ListAttributes HDF5ListGroup
syn keyword igorOperation HDF5LoadData HDF5LoadGroup HDF5LoadImage HDF5OpenFile
syn keyword igorOperation HDF5OpenGroup HDF5SaveData HDF5SaveGroup HDF5SaveImage
syn keyword igorOperation HDF5TestOperation HDF5UnlinkObject HDFInfo
syn keyword igorOperation HDFReadImage HDFReadSDS HDFReadVset Hanning
syn keyword igorOperation HideIgorMenus HideInfo HideProcedures HideTools
syn keyword igorOperation HilbertTransform Histogram ICA IFFT ITCCloseAll2
syn keyword igorOperation ITCCloseDevice2 ITCConfigAllChannels2
syn keyword igorOperation ITCConfigChannel2 ITCConfigChannelReset2
syn keyword igorOperation ITCConfigChannelUpload2 ITCFIFOAvailable2
syn keyword igorOperation ITCFIFOAvailableAll2 ITCGetAllChannelsConfig2
syn keyword igorOperation ITCGetChannelConfig2 ITCGetCurrentDevice2
syn keyword igorOperation ITCGetDeviceInfo2 ITCGetDevices2 ITCGetErrorString2
syn keyword igorOperation ITCGetSerialNumber2 ITCGetState2 ITCGetVersions2
syn keyword igorOperation ITCInitialize2 ITCOpenDevice2 ITCReadADC2
syn keyword igorOperation ITCReadDigital2 ITCReadTimer2 ITCSelectDevice2
syn keyword igorOperation ITCSetDAC2 ITCSetGlobals2 ITCSetModes2 ITCSetState2
syn keyword igorOperation ITCStartAcq2 ITCStopAcq2 ITCUpdateFIFOPosition2
syn keyword igorOperation ITCUpdateFIFOPositionAll2 ITCWriteDigital2
syn keyword igorOperation ImageAnalyzeParticles ImageBlend ImageBoundaryToMask
syn keyword igorOperation ImageEdgeDetection ImageFileInfo ImageFilter
syn keyword igorOperation ImageFocus ImageFromXYZ ImageGLCM ImageGenerateROIMask
syn keyword igorOperation ImageHistModification ImageHistogram ImageInterpolate
syn keyword igorOperation ImageLineProfile ImageLoad ImageMorphology
syn keyword igorOperation ImageRegistration ImageRemoveBackground ImageRestore
syn keyword igorOperation ImageRotate ImageSave ImageSeedFill ImageSkeleton3d
syn keyword igorOperation ImageSnake ImageStats ImageThreshold ImageTransform
syn keyword igorOperation ImageUnwrapPhase ImageWindow IndexSort InsertPoints
syn keyword igorOperation Integrate Integrate2D IntegrateODE Interp3DPath
syn keyword igorOperation Interpolate2 Interpolate3D JCAMPLoadWave
syn keyword igorOperation JointHistogram KMeans KillBackground KillControl
syn keyword igorOperation KillDataFolder KillFIFO KillFreeAxis KillPICTs
syn keyword igorOperation KillPath KillStrings KillVariables KillWaves
syn keyword igorOperation KillWindow Label Layout LayoutPageAction
syn keyword igorOperation LayoutSlideShow Legend LinearFeedbackShiftRegister
syn keyword igorOperation ListBox LoadData LoadPICT LoadPackagePreferences
syn keyword igorOperation LoadWave Loess LombPeriodogram MCC_FindServers
syn keyword igorOperation MFR_CheckForNewBricklets MFR_CloseResultFile
syn keyword igorOperation MFR_CreateOverviewTable MFR_GetBrickletCount
syn keyword igorOperation MFR_GetBrickletData MFR_GetBrickletDeployData
syn keyword igorOperation MFR_GetBrickletMetaData MFR_GetBrickletRawData
syn keyword igorOperation MFR_GetReportTemplate MFR_GetResultFileMetaData
syn keyword igorOperation MFR_GetResultFileName MFR_GetVernissageVersion
syn keyword igorOperation MFR_GetVersion MFR_GetXOPErrorMessage
syn keyword igorOperation MFR_OpenResultFile MLLoadWave Make MakeIndex
syn keyword igorOperation MarkPerfTestTime MatrixConvolve MatrixCorr
syn keyword igorOperation MatrixEigenV MatrixFilter MatrixGLM MatrixGaussJ
syn keyword igorOperation MatrixInverse MatrixLLS MatrixLUBkSub MatrixLUD
syn keyword igorOperation MatrixLUDTD MatrixLinearSolve MatrixLinearSolveTD
syn keyword igorOperation MatrixMultiply MatrixOP MatrixSVBkSub MatrixSVD
syn keyword igorOperation MatrixSchur MatrixSolve MatrixTranspose
syn keyword igorOperation MeasureStyledText Modify ModifyBrowser ModifyCamera
syn keyword igorOperation ModifyContour ModifyControl ModifyControlList
syn keyword igorOperation ModifyFreeAxis ModifyGizmo ModifyGraph ModifyImage
syn keyword igorOperation ModifyLayout ModifyPanel ModifyTable ModifyWaterfall
syn keyword igorOperation MoveDataFolder MoveFile MoveFolder MoveString
syn keyword igorOperation MoveSubwindow MoveVariable MoveWave MoveWindow
syn keyword igorOperation MultiTaperPSD MultiThreadingControl NI4882
syn keyword igorOperation NeuralNetworkRun NeuralNetworkTrain NewCamera
syn keyword igorOperation NewDataFolder NewFIFO NewFIFOChan NewFreeAxis NewGizmo
syn keyword igorOperation NewImage NewLayout NewMovie NewNotebook NewPanel
syn keyword igorOperation NewPath NewWaterfall Note Notebook NotebookAction Open
syn keyword igorOperation OpenHelp OpenNotebook Optimize PCA
syn keyword igorOperation ParseOperationTemplate PathInfo PauseForUser
syn keyword igorOperation PauseUpdate PlayMovie PlayMovieAction PlaySound
syn keyword igorOperation PopupContextualMenu PopupMenu Preferences PrimeFactors
syn keyword igorOperation Print PrintGraphs PrintLayout PrintNotebook
syn keyword igorOperation PrintSettings PrintTable Project PulseStats
syn keyword igorOperation PutScrapText Quit RatioFromNumber Redimension Remove
syn keyword igorOperation RemoveContour RemoveFromGizmo RemoveFromGraph
syn keyword igorOperation RemoveFromLayout RemoveFromTable RemoveImage
syn keyword igorOperation RemoveLayoutObjects RemovePath Rename RenameDataFolder
syn keyword igorOperation RenamePICT RenamePath RenameWindow ReorderImages
syn keyword igorOperation ReorderTraces ReplaceText ReplaceWave Resample
syn keyword igorOperation ResumeUpdate Reverse Rotate SQLHighLevelOp Save
syn keyword igorOperation SaveData SaveExperiment SaveGraphCopy SaveNotebook
syn keyword igorOperation SavePICT SavePackagePreferences SaveTableCopy
syn keyword igorOperation SetActiveSubwindow SetAxis SetBackground
syn keyword igorOperation SetDashPattern SetDataFolder SetDimLabel SetDrawEnv
syn keyword igorOperation SetDrawLayer SetFileFolderInfo SetFormula SetIgorHook
syn keyword igorOperation SetIgorMenuMode SetIgorOption SetMarquee
syn keyword igorOperation SetProcessSleep SetRandomSeed SetScale SetVariable
syn keyword igorOperation SetWaveLock SetWaveTextEncoding SetWindow
syn keyword igorOperation ShowIgorMenus ShowInfo ShowTools Silent Sleep Slider
syn keyword igorOperation Smooth SmoothCustom Sort SortColumns SoundInRecord
syn keyword igorOperation SoundInSet SoundInStartChart SoundInStatus
syn keyword igorOperation SoundInStopChart SoundLoadWave SoundSaveWave
syn keyword igorOperation SphericalInterpolate SphericalTriangulate SplitString
syn keyword igorOperation SplitWave Stack StackWindows StatsANOVA1Test
syn keyword igorOperation StatsANOVA2NRTest StatsANOVA2RMTest StatsANOVA2Test
syn keyword igorOperation StatsAngularDistanceTest StatsChiTest
syn keyword igorOperation StatsCircularCorrelationTest StatsCircularMeans
syn keyword igorOperation StatsCircularMoments StatsCircularTwoSampleTest
syn keyword igorOperation StatsCochranTest StatsContingencyTable StatsDIPTest
syn keyword igorOperation StatsDunnettTest StatsFTest StatsFriedmanTest
syn keyword igorOperation StatsHodgesAjneTest StatsJBTest StatsKDE StatsKSTest
syn keyword igorOperation StatsKWTest StatsKendallTauTest
syn keyword igorOperation StatsLinearCorrelationTest StatsLinearRegression
syn keyword igorOperation StatsMultiCorrelationTest StatsNPMCTest
syn keyword igorOperation StatsNPNominalSRTest StatsQuantiles
syn keyword igorOperation StatsRankCorrelationTest StatsResample StatsSRTest
syn keyword igorOperation StatsSample StatsScheffeTest StatsShapiroWilkTest
syn keyword igorOperation StatsSignTest StatsTTest StatsTukeyTest
syn keyword igorOperation StatsVariancesTest StatsWRCorrelationTest
syn keyword igorOperation StatsWatsonUSquaredTest StatsWatsonWilliamsTest
syn keyword igorOperation StatsWheelerWatsonTest StatsWilcoxonRankTest String
syn keyword igorOperation StructGet StructPut SumDimension SumSeries TDMLoadData
syn keyword igorOperation TDMSaveData TabControl Tag TextBox ThreadGroupPutDF
syn keyword igorOperation ThreadStart Tile TileWindows TitleBox ToCommandLine
syn keyword igorOperation ToolsGrid Triangulate3d URLRequest Unwrap VDT2
syn keyword igorOperation VDTClosePort2 VDTGetPortList2 VDTGetStatus2
syn keyword igorOperation VDTOpenPort2 VDTOperationsPort2 VDTRead2
syn keyword igorOperation VDTReadBinary2 VDTReadBinaryWave2 VDTReadHex2
syn keyword igorOperation VDTReadHexWave2 VDTReadWave2 VDTTerminalPort2
syn keyword igorOperation VDTWrite2 VDTWriteBinary2 VDTWriteBinaryWave2
syn keyword igorOperation VDTWriteHex2 VDTWriteHexWave2 VDTWriteWave2
syn keyword igorOperation VISAControl VISARead VISAReadBinary VISAReadBinaryWave
syn keyword igorOperation VISAReadWave VISAWrite VISAWriteBinary
syn keyword igorOperation VISAWriteBinaryWave VISAWriteWave ValDisplay Variable
syn keyword igorOperation WaveMeanStdv WaveStats WaveTransform WignerTransform
syn keyword igorOperation WindowFunction XLLoadWave cd dir fprintf printf pwd
syn keyword igorOperation sprintf sscanf wfprintf
" }}}

" Functions {{{
syn keyword igorFunction AddListItem AiryA AiryAD AiryB AiryBD AnnotationInfo
syn keyword igorFunction AnnotationList AxisInfo AxisList AxisValFromPixel
syn keyword igorFunction AxonTelegraphAGetDataNum AxonTelegraphAGetDataString
syn keyword igorFunction AxonTelegraphAGetDataStruct AxonTelegraphGetDataNum
syn keyword igorFunction AxonTelegraphGetDataString AxonTelegraphGetDataStruct
syn keyword igorFunction AxonTelegraphGetTimeoutMs AxonTelegraphSetTimeoutMs
syn keyword igorFunction Besseli Besselj Besselk Bessely BinarySearch
syn keyword igorFunction BinarySearchInterp CTabList CaptureHistory
syn keyword igorFunction CaptureHistoryStart CheckName ChildWindowList
syn keyword igorFunction CleanupName ContourInfo ContourNameList
syn keyword igorFunction ContourNameToWaveRef ContourZ ControlNameList
syn keyword igorFunction ConvertTextEncoding CountObjects CountObjectsDFR
syn keyword igorFunction CreationDate CsrInfo CsrWave CsrWaveRef CsrXWave
syn keyword igorFunction CsrXWaveRef DDERequestString DataFolderDir
syn keyword igorFunction DataFolderExists DataFolderRefStatus
syn keyword igorFunction DataFolderRefsEqual DateToJulian Dawson DimDelta
syn keyword igorFunction DimOffset DimSize ExpConvExp ExpConvExpFit
syn keyword igorFunction ExpConvExpFit1Shape ExpConvExpFit1ShapeBL
syn keyword igorFunction ExpConvExpFitBL ExpGauss ExpGaussFit ExpGaussFit1Shape
syn keyword igorFunction ExpGaussFit1ShapeBL ExpGaussFitBL FetchURL FindDimLabel
syn keyword igorFunction FindListItem FontList FontSizeHeight
syn keyword igorFunction FontSizeStringWidth FresnelCos FresnelSin FuncRefInfo
syn keyword igorFunction FunctionInfo FunctionList FunctionPath
syn keyword igorFunction GISGetAllFileFormats GISIgorGISVersion GISSRefsAreEqual
syn keyword igorFunction Gauss Gauss1D Gauss2D GaussFit GaussFit1Width
syn keyword igorFunction GaussFit1WidthBL GaussFitBL GetBrowserLine
syn keyword igorFunction GetBrowserSelection GetDataFolder GetDataFolderDFR
syn keyword igorFunction GetDefaultFont GetDefaultFontSize GetDefaultFontStyle
syn keyword igorFunction GetDimLabel GetEnvironmentVariable GetErrMessage
syn keyword igorFunction GetFormula GetIndependentModuleName GetIndexedObjName
syn keyword igorFunction GetIndexedObjNameDFR GetKeyState GetRTErrMessage
syn keyword igorFunction GetRTError GetRTLocInfo GetRTLocation GetRTStackInfo
syn keyword igorFunction GetScrapText GetUserData GetWavesDataFolder
syn keyword igorFunction GetWavesDataFolderDFR GizmoInfo GizmoScale GrepList
syn keyword igorFunction GrepString GuideInfo GuideNameList HDF5AttributeInfo
syn keyword igorFunction HDF5DatasetInfo HDF5LibraryInfo HDF5TypeInfo Hash
syn keyword igorFunction HyperG0F1 HyperG1F1 HyperG2F1 HyperGNoise HyperGPFQ
syn keyword igorFunction IgorInfo IgorVersion ImageInfo ImageNameList
syn keyword igorFunction ImageNameToWaveRef IndependentModuleList IndexToScale
syn keyword igorFunction IndexedDir IndexedFile Inf Integrate1D Interp2D
syn keyword igorFunction Interp3D ItemsInList JacobiCn JacobiSn JulianToDate
syn keyword igorFunction Laguerre LaguerreA LaguerreGauss LambertW LayoutInfo
syn keyword igorFunction LegendreA ListMatch ListToTextWave ListToWaveRefWave
syn keyword igorFunction LorentzianFit LorentzianFit1Width LorentzianFit1WidthBL
syn keyword igorFunction LorentzianFitBL LowerStr MCC_AutoBridgeBal
syn keyword igorFunction MCC_AutoFastComp MCC_AutoPipetteOffset MCC_AutoSlowComp
syn keyword igorFunction MCC_AutoWholeCellComp MCC_GetBridgeBalEnable
syn keyword igorFunction MCC_GetBridgeBalResist MCC_GetFastCompCap
syn keyword igorFunction MCC_GetFastCompTau MCC_GetHolding MCC_GetHoldingEnable
syn keyword igorFunction MCC_GetMode MCC_GetNeutralizationCap
syn keyword igorFunction MCC_GetNeutralizationEnable MCC_GetOscKillerEnable
syn keyword igorFunction MCC_GetPipetteOffset MCC_GetPrimarySignalGain
syn keyword igorFunction MCC_GetPrimarySignalHPF MCC_GetPrimarySignalLPF
syn keyword igorFunction MCC_GetRsCompBandwidth MCC_GetRsCompCorrection
syn keyword igorFunction MCC_GetRsCompEnable MCC_GetRsCompPrediction
syn keyword igorFunction MCC_GetSecondarySignalGain MCC_GetSecondarySignalLPF
syn keyword igorFunction MCC_GetSlowCompCap MCC_GetSlowCompTau
syn keyword igorFunction MCC_GetSlowCompTauX20Enable MCC_GetSlowCurrentInjEnable
syn keyword igorFunction MCC_GetSlowCurrentInjLevel
syn keyword igorFunction MCC_GetSlowCurrentInjSetlTime MCC_GetWholeCellCompCap
syn keyword igorFunction MCC_GetWholeCellCompEnable MCC_GetWholeCellCompResist
syn keyword igorFunction MCC_SelectMultiClamp700B MCC_SetBridgeBalEnable
syn keyword igorFunction MCC_SetBridgeBalResist MCC_SetFastCompCap
syn keyword igorFunction MCC_SetFastCompTau MCC_SetHolding MCC_SetHoldingEnable
syn keyword igorFunction MCC_SetMode MCC_SetNeutralizationCap
syn keyword igorFunction MCC_SetNeutralizationEnable MCC_SetOscKillerEnable
syn keyword igorFunction MCC_SetPipetteOffset MCC_SetPrimarySignalGain
syn keyword igorFunction MCC_SetPrimarySignalHPF MCC_SetPrimarySignalLPF
syn keyword igorFunction MCC_SetRsCompBandwidth MCC_SetRsCompCorrection
syn keyword igorFunction MCC_SetRsCompEnable MCC_SetRsCompPrediction
syn keyword igorFunction MCC_SetSecondarySignalGain MCC_SetSecondarySignalLPF
syn keyword igorFunction MCC_SetSlowCompCap MCC_SetSlowCompTau
syn keyword igorFunction MCC_SetSlowCompTauX20Enable MCC_SetSlowCurrentInjEnable
syn keyword igorFunction MCC_SetSlowCurrentInjLevel
syn keyword igorFunction MCC_SetSlowCurrentInjSetlTime MCC_SetTimeoutMs
syn keyword igorFunction MCC_SetWholeCellCompCap MCC_SetWholeCellCompEnable
syn keyword igorFunction MCC_SetWholeCellCompResist MPFXEMGPeak
syn keyword igorFunction MPFXExpConvExpPeak MPFXGaussPeak MPFXLorenzianPeak
syn keyword igorFunction MPFXVoigtPeak MacroList MandelbrotPoint MarcumQ
syn keyword igorFunction MatrixCondition MatrixDet MatrixDot MatrixRank
syn keyword igorFunction MatrixTrace ModDate NVAR_Exists NaN NameOfWave
syn keyword igorFunction NewFreeDataFolder NewFreeWave NormalizeUnicode
syn keyword igorFunction NumVarOrDefault NumberByKey OperationList PICTInfo
syn keyword igorFunction PICTList PadString PanelResolution ParamIsDefault
syn keyword igorFunction ParseFilePath PathList Pi PixelFromAxisVal PolygonArea
syn keyword igorFunction PossiblyQuoteName ProcedureText RemoveByKey
syn keyword igorFunction RemoveEnding RemoveFromList RemoveListItem
syn keyword igorFunction ReplaceNumberByKey ReplaceString ReplaceStringByKey
syn keyword igorFunction SQL2DBinaryWaveToTextWave SQLAllocHandle SQLAllocStmt
syn keyword igorFunction SQLBinaryWavesToTextWave SQLBindCol SQLBindParameter
syn keyword igorFunction SQLBrowseConnect SQLBulkOperations SQLCancel
syn keyword igorFunction SQLCloseCursor SQLColAttributeNum SQLColAttributeStr
syn keyword igorFunction SQLColumnPrivileges SQLColumns SQLConnect
syn keyword igorFunction SQLDataSources SQLDescribeCol SQLDescribeParam
syn keyword igorFunction SQLDisconnect SQLDriverConnect SQLDrivers SQLEndTran
syn keyword igorFunction SQLError SQLExecDirect SQLExecute SQLFetch
syn keyword igorFunction SQLFetchScroll SQLForeignKeys SQLFreeConnect SQLFreeEnv
syn keyword igorFunction SQLFreeHandle SQLFreeStmt SQLGetConnectAttrNum
syn keyword igorFunction SQLGetConnectAttrStr SQLGetCursorName SQLGetDataNum
syn keyword igorFunction SQLGetDataStr SQLGetDescFieldNum SQLGetDescFieldStr
syn keyword igorFunction SQLGetDescRec SQLGetDiagFieldNum SQLGetDiagFieldStr
syn keyword igorFunction SQLGetDiagRec SQLGetEnvAttrNum SQLGetEnvAttrStr
syn keyword igorFunction SQLGetFunctions SQLGetInfoNum SQLGetInfoStr
syn keyword igorFunction SQLGetStmtAttrNum SQLGetStmtAttrStr SQLGetTypeInfo
syn keyword igorFunction SQLMoreResults SQLNativeSql SQLNumParams
syn keyword igorFunction SQLNumResultCols SQLNumResultRowsIfKnown
syn keyword igorFunction SQLNumRowsFetched SQLParamData SQLPrepare
syn keyword igorFunction SQLPrimaryKeys SQLProcedureColumns SQLProcedures
syn keyword igorFunction SQLPutData SQLReinitialize SQLRowCount
syn keyword igorFunction SQLSetConnectAttrNum SQLSetConnectAttrStr
syn keyword igorFunction SQLSetCursorName SQLSetDescFieldNum SQLSetDescFieldStr
syn keyword igorFunction SQLSetDescRec SQLSetEnvAttrNum SQLSetEnvAttrStr
syn keyword igorFunction SQLSetPos SQLSetStmtAttrNum SQLSetStmtAttrStr
syn keyword igorFunction SQLSpecialColumns SQLStatistics SQLTablePrivileges
syn keyword igorFunction SQLTables SQLTextWaveTo2DBinaryWave
syn keyword igorFunction SQLTextWaveToBinaryWaves SQLUpdateBoundValues
syn keyword igorFunction SQLXOPCheckState SVAR_Exists ScreenResolution Secs2Date
syn keyword igorFunction Secs2Time SelectNumber SelectString
syn keyword igorFunction SetEnvironmentVariable SortList SpecialCharacterInfo
syn keyword igorFunction SpecialCharacterList SpecialDirPath SphericalBessJ
syn keyword igorFunction SphericalBessJD SphericalBessY SphericalBessYD
syn keyword igorFunction SphericalHarmonics StartMSTimer StatsBetaCDF
syn keyword igorFunction StatsBetaPDF StatsBinomialCDF StatsBinomialPDF
syn keyword igorFunction StatsCMSSDCDF StatsCauchyCDF StatsCauchyPDF StatsChiCDF
syn keyword igorFunction StatsChiPDF StatsCorrelation StatsDExpCDF StatsDExpPDF
syn keyword igorFunction StatsEValueCDF StatsEValuePDF StatsErlangCDF
syn keyword igorFunction StatsErlangPDF StatsErrorPDF StatsExpCDF StatsExpPDF
syn keyword igorFunction StatsFCDF StatsFPDF StatsFriedmanCDF StatsGEVCDF
syn keyword igorFunction StatsGEVPDF StatsGammaCDF StatsGammaPDF
syn keyword igorFunction StatsGeometricCDF StatsGeometricPDF StatsHyperGCDF
syn keyword igorFunction StatsHyperGPDF StatsInvBetaCDF StatsInvBinomialCDF
syn keyword igorFunction StatsInvCMSSDCDF StatsInvCauchyCDF StatsInvChiCDF
syn keyword igorFunction StatsInvDExpCDF StatsInvEValueCDF StatsInvExpCDF
syn keyword igorFunction StatsInvFCDF StatsInvFriedmanCDF StatsInvGammaCDF
syn keyword igorFunction StatsInvGeometricCDF StatsInvKuiperCDF
syn keyword igorFunction StatsInvLogNormalCDF StatsInvLogisticCDF
syn keyword igorFunction StatsInvMaxwellCDF StatsInvMooreCDF
syn keyword igorFunction StatsInvNBinomialCDF StatsInvNCChiCDF StatsInvNCFCDF
syn keyword igorFunction StatsInvNormalCDF StatsInvParetoCDF StatsInvPoissonCDF
syn keyword igorFunction StatsInvPowerCDF StatsInvQCDF StatsInvQpCDF
syn keyword igorFunction StatsInvRayleighCDF StatsInvRectangularCDF
syn keyword igorFunction StatsInvSpearmanCDF StatsInvStudentCDF
syn keyword igorFunction StatsInvTopDownCDF StatsInvTriangularCDF
syn keyword igorFunction StatsInvUsquaredCDF StatsInvVonMisesCDF
syn keyword igorFunction StatsInvWeibullCDF StatsKuiperCDF StatsLogNormalCDF
syn keyword igorFunction StatsLogNormalPDF StatsLogisticCDF StatsLogisticPDF
syn keyword igorFunction StatsMaxwellCDF StatsMaxwellPDF StatsMedian
syn keyword igorFunction StatsMooreCDF StatsNBinomialCDF StatsNBinomialPDF
syn keyword igorFunction StatsNCChiCDF StatsNCChiPDF StatsNCFCDF StatsNCFPDF
syn keyword igorFunction StatsNCTCDF StatsNCTPDF StatsNormalCDF StatsNormalPDF
syn keyword igorFunction StatsParetoCDF StatsParetoPDF StatsPermute
syn keyword igorFunction StatsPoissonCDF StatsPoissonPDF StatsPowerCDF
syn keyword igorFunction StatsPowerNoise StatsPowerPDF StatsQCDF StatsQpCDF
syn keyword igorFunction StatsRayleighCDF StatsRayleighPDF StatsRectangularCDF
syn keyword igorFunction StatsRectangularPDF StatsRunsCDF StatsSpearmanRhoCDF
syn keyword igorFunction StatsStudentCDF StatsStudentPDF StatsTopDownCDF
syn keyword igorFunction StatsTriangularCDF StatsTriangularPDF StatsTrimmedMean
syn keyword igorFunction StatsUSquaredCDF StatsVonMisesCDF StatsVonMisesNoise
syn keyword igorFunction StatsVonMisesPDF StatsWaldCDF StatsWaldPDF
syn keyword igorFunction StatsWeibullCDF StatsWeibullPDF StopMSTimer
syn keyword igorFunction StrVarOrDefault StringByKey StringFromList StringList
syn keyword igorFunction StudentA StudentT TDMAddChannel TDMAddGroup
syn keyword igorFunction TDMAppendDataValues TDMAppendDataValuesTime
syn keyword igorFunction TDMChannelPropertyExists TDMCloseChannel TDMCloseFile
syn keyword igorFunction TDMCloseGroup TDMCreateChannelProperty TDMCreateFile
syn keyword igorFunction TDMCreateFileProperty TDMCreateGroupProperty
syn keyword igorFunction TDMFilePropertyExists TDMGetChannelPropertyNames
syn keyword igorFunction TDMGetChannelPropertyNum TDMGetChannelPropertyStr
syn keyword igorFunction TDMGetChannelPropertyTime TDMGetChannelPropertyType
syn keyword igorFunction TDMGetChannelStringPropertyLen TDMGetChannels
syn keyword igorFunction TDMGetDataType TDMGetDataValues TDMGetDataValuesTime
syn keyword igorFunction TDMGetFilePropertyNames TDMGetFilePropertyNum
syn keyword igorFunction TDMGetFilePropertyStr TDMGetFilePropertyTime
syn keyword igorFunction TDMGetFilePropertyType TDMGetFileStringPropertyLen
syn keyword igorFunction TDMGetGroupPropertyNames TDMGetGroupPropertyNum
syn keyword igorFunction TDMGetGroupPropertyStr TDMGetGroupPropertyTime
syn keyword igorFunction TDMGetGroupPropertyType TDMGetGroupStringPropertyLen
syn keyword igorFunction TDMGetGroups TDMGetLibraryErrorDescription
syn keyword igorFunction TDMGetNumChannelProperties TDMGetNumChannels
syn keyword igorFunction TDMGetNumDataValues TDMGetNumFileProperties
syn keyword igorFunction TDMGetNumGroupProperties TDMGetNumGroups
syn keyword igorFunction TDMGroupPropertyExists TDMOpenFile TDMOpenFileEx
syn keyword igorFunction TDMRemoveChannel TDMRemoveGroup TDMReplaceDataValues
syn keyword igorFunction TDMReplaceDataValuesTime TDMSaveFile
syn keyword igorFunction TDMSetChannelPropertyNum TDMSetChannelPropertyStr
syn keyword igorFunction TDMSetChannelPropertyTime TDMSetDataValues
syn keyword igorFunction TDMSetDataValuesTime TDMSetFilePropertyNum
syn keyword igorFunction TDMSetFilePropertyStr TDMSetFilePropertyTime
syn keyword igorFunction TDMSetGroupPropertyNum TDMSetGroupPropertyStr
syn keyword igorFunction TDMSetGroupPropertyTime TableInfo TagVal TagWaveRef
syn keyword igorFunction TextEncodingCode TextEncodingName TextFile
syn keyword igorFunction ThreadGroupCreate ThreadGroupGetDF ThreadGroupGetDFR
syn keyword igorFunction ThreadGroupRelease ThreadGroupWait ThreadProcessorCount
syn keyword igorFunction ThreadReturnValue TraceFromPixel TraceInfo
syn keyword igorFunction TraceNameList TraceNameToWaveRef TrimString URLDecode
syn keyword igorFunction URLEncode UnPadString UniqueName
syn keyword igorFunction UnsetEnvironmentVariable UpperStr VariableList Variance
syn keyword igorFunction Voigt VoigtFit VoigtFit1Shape VoigtFit1Shape1Width
syn keyword igorFunction VoigtFit1Shape1WidthBL VoigtFit1ShapeBL VoigtFitBL
syn keyword igorFunction VoigtFunc WMFindWholeWord WaveCRC WaveDims WaveExists
syn keyword igorFunction WaveInfo WaveList WaveMax WaveMin WaveName
syn keyword igorFunction WaveRefIndexed WaveRefIndexedDFR WaveRefWaveToList
syn keyword igorFunction WaveRefsEqual WaveTextEncoding WaveType WaveUnits
syn keyword igorFunction WhichListItem WinList WinName WinRecreation WinType
syn keyword igorFunction XWaveName XWaveRefFromTrace ZernikeR abs acos acosh
syn keyword igorFunction alog area areaXY asin asinh atan atan2 atanh beta betai
syn keyword igorFunction binomial binomialNoise binomialln cabs ceil cequal
syn keyword igorFunction char2num chebyshev chebyshevU cmplx cmpstr conj cos
syn keyword igorFunction cosIntegral cosh cot coth cpowi csc csch date date2secs
syn keyword igorFunction datetime defined deltax digamma dilogarithm ei enoise
syn keyword igorFunction equalWaves erf erfc erfcw exists exp expInt
syn keyword igorFunction expIntegralE1 expNoise fDAQmx_AI_GetReader
syn keyword igorFunction fDAQmx_AO_UpdateOutputs fDAQmx_CTR_Finished
syn keyword igorFunction fDAQmx_CTR_IsFinished fDAQmx_CTR_IsPulseFinished
syn keyword igorFunction fDAQmx_CTR_ReadCounter fDAQmx_CTR_ReadWithOptions
syn keyword igorFunction fDAQmx_CTR_SetPulseFrequency fDAQmx_CTR_Start
syn keyword igorFunction fDAQmx_ConnectTerminals fDAQmx_DIO_Finished
syn keyword igorFunction fDAQmx_DIO_PortWidth fDAQmx_DIO_Read fDAQmx_DIO_Write
syn keyword igorFunction fDAQmx_DeviceNames fDAQmx_DisconnectTerminals
syn keyword igorFunction fDAQmx_ErrorString fDAQmx_ExternalCalDate
syn keyword igorFunction fDAQmx_NumAnalogInputs fDAQmx_NumAnalogOutputs
syn keyword igorFunction fDAQmx_NumCounters fDAQmx_NumDIOPorts fDAQmx_ReadChan
syn keyword igorFunction fDAQmx_ReadNamedChan fDAQmx_ResetDevice
syn keyword igorFunction fDAQmx_ScanGetAvailable fDAQmx_ScanGetNextIndex
syn keyword igorFunction fDAQmx_ScanStart fDAQmx_ScanStop fDAQmx_ScanWait
syn keyword igorFunction fDAQmx_ScanWaitWithTimeout fDAQmx_SelfCalDate
syn keyword igorFunction fDAQmx_SelfCalibration fDAQmx_WF_IsFinished
syn keyword igorFunction fDAQmx_WF_WaitUntilFinished fDAQmx_WaveformStart
syn keyword igorFunction fDAQmx_WaveformStop fDAQmx_WriteChan factorial fakedata
syn keyword igorFunction faverage faverageXY floor gamma gammaEuler gammaInc
syn keyword igorFunction gammaNoise gammln gammp gammq gcd gnoise hcsr hermite
syn keyword igorFunction hermiteGauss imag interp inverseERF inverseERFC leftx
syn keyword igorFunction limit ln log logNormalNoise lorentzianNoise magsqr max
syn keyword igorFunction mean median min mod norm note num2char num2istr num2str
syn keyword igorFunction numpnts numtype p2rect pcsr pnt2x poissonNoise poly
syn keyword igorFunction poly2D qcsr r2polar real rightx round sawtooth
syn keyword igorFunction scaleToIndex sec sech sign sin sinIntegral sinc sinh
syn keyword igorFunction sqrt str2num stringCRC stringmatch strlen strsearch sum
syn keyword igorFunction tan tango_close_device tango_command_inout
syn keyword igorFunction tango_compute_image_proj tango_get_dev_attr_list
syn keyword igorFunction tango_get_dev_black_box tango_get_dev_cmd_list
syn keyword igorFunction tango_get_dev_status tango_get_dev_timeout
syn keyword igorFunction tango_get_error_stack tango_open_device
syn keyword igorFunction tango_ping_device tango_read_attribute
syn keyword igorFunction tango_read_attributes tango_resume_attr_monitor
syn keyword igorFunction tango_set_attr_monitor_period tango_set_dev_timeout
syn keyword igorFunction tango_start_attr_monitor tango_stop_attr_monitor
syn keyword igorFunction tango_suspend_attr_monitor tango_write_attribute
syn keyword igorFunction tango_write_attributes tanh ticks time trunc vcsr
syn keyword igorFunction viAssertIntrSignal viAssertTrigger viAssertUtilSignal
syn keyword igorFunction viClear viClose viDisableEvent viDiscardEvents
syn keyword igorFunction viEnableEvent viFindNext viFindRsrc viGetAttribute
syn keyword igorFunction viGetAttributeString viGpibCommand viGpibControlATN
syn keyword igorFunction viGpibControlREN viGpibPassControl viGpibSendIFC viIn16
syn keyword igorFunction viIn32 viIn8 viLock viMapAddress viMapTrigger
syn keyword igorFunction viMemAlloc viMemFree viMoveIn16 viMoveIn32 viMoveIn8
syn keyword igorFunction viMoveOut16 viMoveOut32 viMoveOut8 viOpen
syn keyword igorFunction viOpenDefaultRM viOut16 viOut32 viOut8 viPeek16
syn keyword igorFunction viPeek32 viPeek8 viPoke16 viPoke32 viPoke8 viRead
syn keyword igorFunction viReadSTB viSetAttribute viSetAttributeString
syn keyword igorFunction viStatusDesc viTerminate viUnlock viUnmapAddress
syn keyword igorFunction viUnmapTrigger viUsbControlIn viUsbControlOut
syn keyword igorFunction viVxiCommandQuery viWaitOnEvent viWrite wnoise x2pnt
syn keyword igorFunction xcsr zcsr zeta
" }}}

syn region  igorStringDQ  start=+"+ end=+"+ skip=+\\\\\|\\"+
syn region  igorStringQ   start=+'+ end=+'+ skip=+\\\\\|\\'+
syn region  igorASCII     start=+ASCII85Begin+ end=+ASCII85End+ skip=+"|'+

syn keyword igorStructure structure endstructure contained
syn keyword igorStructure struct
syn keyword igorPicture   picture contained
syn keyword igorConstant  nan inf
syn keyword igorStat      break return continue
syn keyword igorCond      if else elseif endif switch endswitch strswitch
syn keyword igorMod       multithread AbortOnRTE AbortOnValue try catch endtry
syn keyword igorRepeat    for endfor do while
syn keyword igorLabel     case default
syn match   igorSpecial   "\(V\|S\)_[a-zA-Z]\+" " auto variables from operations like V_flag, S_names etc.

syn keyword igorDefine    threadsafe static macro window function endmacro end contained
" we must also highlight end as closing for menu and submenu (which we don't fold)
syn keyword igorDefine    menu submenu end Prompt DoPrompt WaveClear
syn match   igorDefine    "proc\s\+[^=]"he=e-1 contained

syn keyword igorType      constant strconstant variable string svar
syn keyword igorType      nvar funcref dfref
syn keyword igorType      char uchar int16 uint16 int32 uint32 int64 uint64 float double
" hack, highlight static also in front of Constant and StrConstant
syn match   igorType      "static\s\+\(StrConstant\|Constant\)"
syn match   igorType      "^\s*\<wave\>"

syn match   igorPreproc   "^#\(pragma\|define\|else\|elif\|endif\|ifdef\|ifndef\|if\|include\|undef\)"
syn match   igorDelimiter "[(){}]\|\[\|\]"

syn match   igorComment   "//.*"  contains=igorExtra
syn match   igorExtra     "\(todo\|fixme\)"  contained

syn region  igorFunctionFold  start="^\s*\(\|static\s\+\|threadsafe\s\+\|static\s\+threadsafe\s\+\|threadsafe\s\+static\s\+\)function\(\s\+\|\/\)" end="^\s*end\(\s\+\|$\)" fold transparent keepend contains=ALL
syn region  igorMacroFold     start="^\s*\(macro\|window\|proc\)\s\+" end="^\s*\(end\|endmacro\)\(\s\+\|$\)" fold transparent keepend contains=ALL
syn region  igorStructureFold start="^\s*\(\|static\s\+\)structure " end="^\s*endstructure" fold transparent keepend contains=ALL
syn region  igorPictureFold start="^\s*\(\|static\s\+\)picture " end="^\s*end" fold transparent keepend contains=ALL

if exists("igorpro_default_colors")
  hi igorStructure guifg=#0000FF ctermfg=4*
  hi igorPicture   guifg=#0000FF ctermfg=4*
  hi igorConstant  guifg=#C34E00 ctermfg=3*
  hi igorDefine    guifg=#0000FF ctermfg=4*
  hi igorType      guifg=#0000FF ctermfg=4*
  hi igorCond      guifg=#0000FF ctermfg=4*
  hi igorMod       guifg=#0000FF ctermfg=4*
  hi igorStat      guifg=#0000FF ctermfg=4*
  hi igorRepeat    guifg=#0000FF ctermfg=4*
  hi igorLabel     guifg=#0000FF ctermfg=4*

  hi igorFunction  guifg=#C34E00 ctermfg=3*
  hi igorOperation guifg=#007575 ctermfg=4*
  hi igorPreProc   guifg=#CC00A3 ctermfg=5*
  hi igorStringDQ  guifg=#009C00 ctermfg=2*
  hi igorStringQ   guifg=#009C00 ctermfg=2*
  hi igorComment   guifg=#FF0000 ctermfg=1*
  hi link igorExtra   Todo
else
  hi link igorOperation Function
  hi link igorFunction  Function
  hi link igorPicture   Function

  hi link igorStringDQ  String
  hi link igorStringQ   String

  hi link igorStructure Structure
  hi link igorConstant  Constant
  hi link igorCond      Conditional
  hi link igorStat      Statement
  hi link igorRepeat    Repeat
  hi link igorLabel     Label
  hi link igorSpecial   Special
  hi link igorMod       Special

  hi link igorDefine    Define
  hi link igorType      Type
  hi link igorPreproc   PreProc
  hi link igorDelimiter Delimiter
  hi link igorComment   Comment
  hi link igorExtra     Todo
endif

let b:current_syntax = "igorpro"

" vim: set fdm=marker:
